.8086
	include		casm.inc
	include		ega.inc


;****************************************************************************
CODE	segment	byte public
	assume cs:CODE

	scr_wid         dw	80
	plane_size	dw	?
	first_page	dw	?
	second_page	dw	?
	curr_page       dw	?

				;edge masks wich are  used for bit operations
	BMASKS          db      080H,040H,020H,010H,08H,04H,02H,01H
	REDGEMSK	db	080H,0C0H,0E0H,0F0H,0F8H,0FCH,0FEH,0FFH
	LEDGEMSK        db      0FFH,07FH,03FH,01FH,0FH,07H,03H,01H


	lupper_offs     dw      ?
	rupper_offs	dw	?

	width		dw	?
	height		dw	?

	firstb_wid	dw	?
	secndb_wid	dw	?

	sum		dw	?
	dely            dw	?

	curr_patt       dw	?
	curr_cell	dw	?
	curr_buff	dw	?
	curr_char	dw	?


	pattern         db	32	dup(0ffh)
	textpattern	db	32	dup(0aah)

	cell1		dw	?
	next_action	dw	?

	row_add		dw	?
	byte_width	dw	?
        row_counter	dw	?
	sour_row_add	dw	?
	dest_row_add	dw	?

	sp_store	dw	?
	ss_store	dw	?
	prevch_ptr	dw	?


	current_line    dw	?		;pointer to current line mode
	char_height	dw	?               ;height of the cell
	startline	dw	?		;start line for the character
	vdots		dw      ?		;character font height
	char_set_base	dw	2	dup(?)	; raster  font address

	pattern_latch   dw	0               ;pointer to pattern latch
	pattern_l_seg   dw	?
	color_cell	dw	32
	color_cell_seg	dw	?


	textcolor	db	?
	textbcolor	db      ?
	text_style	db      ?
	rot_counter	db	?

	string_seg	dw	?
	icon_start	dw	?
	buffer_offs	dw	?


	alter_planes	db	?
	curr_plane	db	?
	fst_edge	db	?
	sec_edge	db	?
	read_plane	db	?
	write_plane	db	?

	baccolor        db	?
	forcolor        db	?	;current pattern colors
	ledge		db	?
	redge		db	?
	left_part	db	?
	right_part	db	?
	one_byte        db	?
	transffer_delay	db	?

	draw_color	db	?
	draw_style	db	?
	line_logic	db	?
	doomy		db	?

	icon_alter_planes	db	?
	dom			db	?

        str_len                 db      ?



;*****************************************************************************
;        Procedures  wich are for inner  use...

	use_ega_port	proc	near		;this procedure uses
		out	dx,al			;register-function
		inc	dx
		mov	al,ah
		out	dx,al
		ret
	use_ega_port	endp


	curr_patt_offs	proc	near
		and	ax,0fh
		shl	ax,1
		div8	bx
		test	bx,1
		$IF	NZ
			inc	ax
		$ENDIF
		mov	curr_patt,ax
		ret
	curr_patt_offs	endp


	w0_data_planes	proc	near
		mov	dx,GPX_IR		;Set\Res =0
		xor	al,al
		out	dx,al
		inc	dx
		out	dx,al
		dec	dx

		mov	al,1			;pixels in alter_planes are
		out	dx,al			;xored with data
		inc	dx			;in other planes are xored
		mov	al,alter_planes		;with Set\Res wich is 0
		not	al			;reverce
		out	dx,al			;i.e not changed
		ret
	w0_data_planes	endp


;*****************************************************************************
	InitGraphics	proc	far
		push	bp
		mov	bp,sp
		mov	ah,0
		mov	al,[bp+6]
		int	10h

		mov	first_page,_480_PAGE0
		mov	second_page,_480_PAGE1
		mov	plane_size,_480_PLANE
		mov	curr_page,_480_PAGE0
		mov	color_cell_seg,_480_PAGE1
		mov	pattern_l_seg,_480_PAGE1

		cmp	word ptr [bp+6],010h
		jg	vga_required
			mov	first_page,_350_PAGE0
			mov	second_page,_350_PAGE1
			mov	plane_size,_350_PLANE
			mov	curr_page,_350_PAGE0
			mov	color_cell_seg,_350_PAGE1
			mov	pattern_l_seg,_350_PAGE1
		vga_required:
		pop     bp
		ret     2
	InitGraphics endp

	LeaveGraphics   proc  far
		mov	ah,0
		mov	al,3
		int	010h
		ret
	LeaveGraphics endp
;******************************************************************************
        start_c_proc    set_fill_pattern
                push    [bp+6]
                push    [bp+8]
                push    [bp+12]
                push    [bp+10]
                call far ptr _set_fill_pattern

        end_c_proc      set_fill_pattern ,8


	start_c_proc	_set_fill_pattern
	mov	alter_planes,0fh
	call	w0_data_planes

	cld                                     ;clears  direction flag
	lds	si,dword ptr [bp+6]             ;ds:si points to pattern
	les	di,dword ptr pattern_latch	;es:di points to latch buffer

	mov	bh,[bp+10]                      ;set current pattern colors
	mov     forcolor,bh
	mov     bl,[bp+12]                      ;set current background color
	mov     baccolor,bl

	;update mask buffer and  latch buffer with  current  pattern  values
	set_write_mask	whole_data		;all bits are from data

	;fill latch buffer with uniform backround color
	set_wr_mode	2
	enable_planes	0fh			;enable all planes
	set_rot_logic	0,repl_			;set rotate and logic
	mov     al,baccolor			;and color
	mov     cx,32				;do for every pattern byte
	rep	stosb

	;and now sets forground pixels using xor-technique
	set_wr_mode	0
	xor     bl,bh				;get alternative colors
	enable_planes	bl             		;enable this planes
	set_rot_logic	0,xor_                  ;set rotate and logic=xor
	mov     di,pattern_latch                ;di points to pattern buffer
	cmp     cl,es:[di] 			;store bacground at latch
	xor     bx,bx				;bx=0
	mov     cx,32                           ;update 32 bytes

	set_pattern_forg:
		lodsb				;get current pattern byte
		mov	pattern[bx],al		;store at mask buffer
		stosb				;update forground pixels
		inc     bx			;point to next mask byte
	loop	set_pattern_forg		;one more byte ?

	end_c_proc	_set_fill_pattern ,8

;******************************************************************************

	start_c_proc	set_text_pattern
		cld
		cli
		lds	si,dword ptr [bp+6]	;point to pattern
		mov	ax,CODE
		mov	es,ax
		mov	di,offset textpattern
		mov	cx,32			;get pattern size
			rep	movsb
		sti
	end_c_proc	set_text_pattern ,4
;******************************************************************************

        start_c_proc    set_line
                push    [bp+6]
                push    [bp+8]
                push    [bp+10]
                push    [bp+12]
                call    far ptr _set_line
        end_c_proc      set_line , 8

	start_c_proc	_set_line
	cli
	mov	bl,line_logic

	mov	sp_store,sp
	mov	sp,scr_wid

	set_rot_logic   0,bl			;set current rotation and logic
	set_wr_mode	2                       ;set current write mode


	enable_planes	0fh			;enable all planes to write
	mov	ds,curr_page			;manage  ds points to curr vp

	mov	bx,[bp+6]                       ;loads coordinates to registers
	mov	ax,[bp+8]                       ;
	mov	cx,[bp+10]                      ;
	mov	dx,[bp+12]                      ;

	cmp 	ax,dx                           ;if   y > y1
	$IF	G                               ;exchange coordinates
		xchg	ax,dx
		xchg 	bx,cx
	$ENDIF                                  ;from here  y1>=y

	cmp     draw_style,0
	$IF     NE
		push	ax
		push	bx
		call	curr_patt_offs
		pop	bx
		pop	ax
	$ENDIF



	sub	dx,ax                           ;si=dely
	mov	si,dx                           ;

	mov	dx,cx                           ;calculate delx=|x1-x|
	sub	dx,bx
	$IF	L
		neg	dx                      ;
	$ENDIF                                  ;dx=|x1-x|
	mov     bp,dx                           ;bp=delx

	mov	di,bx
	div8    di                              ;di=x/8

	mul     sp				;ax=yoffset
	add     di,ax				;get initial offset

	cmp	bp,si                           ;calculate line-drawing mode
	$IF     GE	                        ;if dx>=dy horizontal drawing
		mov	sum,bp                  ;sum=delx
		cmp	cx,bx                   ;x1 >= x ?
		$IF     GE                      ;
			cmp     draw_style,0
                        $IF     E
			        mov	dx,offset  h_x1_ge_x
                        $ELSE
                                mov     dx,offset  h_x1_ge_x_patt
                        $ENDIF
		$ELSE
                        cmp     draw_style,0
                        $IF     E
			        mov	dx,offset  h_x1_ls_x
                        $ELSE
                                mov     dx,offset  h_x1_ls_x_patt
                        $ENDIF
		$ENDIF
	$ELSE
		mov	sum,si                  ;sum=dely
		cmp     cx,bx                   ;x1 >= x ?
		$IF     GE
                        cmp     draw_style,0
                        $IF     E
			        mov	dx,offset  v_x1_ge_x
                        $ELSE
                                mov     dx,offset  v_x1_ge_x_patt
                        $ENDIF
		$ELSE
                        cmp     draw_style,0
                        $IF     E
			        mov	dx,offset  v_x1_ls_x
                        $ELSE
                                mov     dx,offset  v_x1_ls_x_patt
                        $ENDIF
		$ENDIF
	$ENDIF

	mov	current_line,dx
	point_GPX_to	8			;points to write mask func

	and	bx,7				;in-byte position
	mov     ah,draw_color			;set up current color
	mov     al,BMASKS[bx]			;set up initial drawing mask

	mov     bx,sum				;bx=sum
	mov     cx,bx				;at first  count=sum+1
	inc     cx
	out     dx,al				;set up initial mask with ega

	cmp     draw_style,0			;check for patterned line
	$IF     NE
                mov     dely,si
                mov     si,bx
                mov     bx,curr_patt
        $ENDIF

	jmp     current_line			;jump to current line type
	;------------horizontal case-------------
	h_x1_ge_x:
		out	dx,al                   ;pixel mask
		cmp	ah,[di]                 ;latch
		mov	[di],ah                 ;store point of curr color

		sub  bx,si                      ;sum-=dy
		$IF  LE                         ;if  sum <= 0
			add  di,sp		;y++
			add  bx,bp              ;sum+=dx
		$ENDIF

		ror     al,1                    ;update pixel mask
		adc     di,0                    ;if byte overflowed inc address
	loop	h_x1_ge_x                       ;one more point?
	jmp     set_line_exit
	;---------------------------------------

	h_x1_ls_x:
		out	dx,al                   ;mask
		cmp	ah,[di]                 ;latch
		mov	[di],ah                 ;store point of curr color

		sub     bx,si                   ;sum-=dy
		$IF	LE		        ;if  sum <= 0
			add  di,sp		;y++
			add  bx,bp              ;sum+=dx
		$ENDIF

		rol     al,1                    ;if byte overflowed update
		sbb     di,0                    ;byte address

	loop	h_x1_ls_x                       ;one more point ?
	jmp     set_line_exit
	;-------vertical  case-------------------
	v_x1_ge_x:
		cmp	ah,[di]                 ;latch
		mov	[di],ah                 ;store point of current color

		sub	bx,bp                   ;sum-=dx
		$IF	LE                      ;if  sum <= 0
			add   bx,si             ;sum+=dy
			ror   al,1              ;x++
			adc   di,0	        ;
			out   dx,al             ;mask is changed
		$ENDIF

		add     di,sp			;y++
	loop	v_x1_ge_x
	jmp	set_line_exit

	;----------------------------------------
	v_x1_ls_x:
		cmp	ah,[di]                 ;latch
		mov	[di],ah                 ;store point of current color

		sub     bx,bp                   ;sum-=dx
		$IF	LE                      ;if  sum <= 0
			add	bx,si           ;sum+=dy
			rol	al,1            ;x--
			sbb	di,0	        ;if byte overflowed update addr
			out	dx,al           ;mask  is changed
		$ENDIF

		add     di,sp			;  y++
	loop    v_x1_ls_x
	jmp     set_line_exit
	;-----for patterned line ----------------------------------
	h_x1_ge_x_patt:
		out	dx,al;			;pixel mask
		set_patt_pixel

		sub	si,dely			; sum-=dy
		$IF	LE			; if  sum <= 0
			add	di,sp		; y++
			add	si,bp		; sum+=dx
			add	bx,2		; go to new pattern row
			and	bx,01fh		; get patt paragraph offs
		$ENDIF

		ror	al,1
		$IF	C
			inc	di		;advance to nect cell
			xor	bx,1		;get adjaicent pattern byte
		$ENDIF
	loop	h_x1_ge_x_patt			; one more point ?
	jmp	set_line_exit
	;----------------------------------------
	h_x1_ls_x_patt:
		out	dx,al			;set write mask
		set_patt_pixel			; set pixel with current color

		sub	si,dely			;sum-=dy
		$IF	LE			;if  sum <= 0
			add	di,sp		;y++
			add	si,bp		;sum+=dx
			add	bx,2		; go to new pattern row
			and	bx,01fh
		$ENDIF
		rol	al,1
		$IF	C
			dec   di
			xor   bx,1
		$ENDIF
	loop	h_x1_ls_x_patt			; one more point ?
	jmp	set_line_exit
	;----------------------------------------
	v_x1_ge_x_patt:
		set_patt_pixel			; set pixel with curr color
		sub	si,bp			; sum-=dx
		jg	patt1			; if  sum <= 0
			add	si,dely		; sum+=dy
			ror	al,1		; x++
			out	dx,al		; set  new mask
			jnc	patt1
				inc	di
				xor	bx,1	;advance to adjaicent byte

		patt1:
			add	di,sp		; y++
		add	bx,2			; go to new pattern row
		and	bx,01fh			; get patt paragr offs
	loop	v_x1_ge_x_patt
	jmp	set_line_exit
	;----------------------------------------
	v_x1_ls_x_patt:
		set_patt_pixel			; set pixel with curr color
		sub	si,bp			; sum-=dx
		jg	patt2			;if  sum <= 0
			add	si,dely		;sum+=dy
			rol	al,1		;x--
			out	dx,al
			jnc	patt2
				dec	di
				xor	bx,1
		patt2:
		add	di,sp			;y++
		add	bx,2
		and	bx,01fh
	loop	v_x1_ls_x_patt
	;----------------------------------------
	set_line_exit:
	mov	sp,sp_store
	sti
	end_c_proc    _set_line ,8
;******************************************************************************
	start_c_proc	replace_colors
                push    [bp+6]
                push    [bp+8]
                push    [bp+10]
                push    [bp+12]
                push    [bp+14]
                push    [bp+16]
                call    far ptr _replace_colors
        end_c_proc      replace_colors,12

	start_c_proc	_replace_colors
	cli
	cld
	mov	alter_planes,0fh
	call	w0_data_planes

	mov	ds,curr_page
	mov	es,curr_page

	set_wr_mode	8                       ;set color read mode
	set_rot_logic	0,xor_			;use xor-technique
	set_r1_color	[bp+14]			;get replaced color

	mov	bl,[bp+14]
	mov	bh,[bp+16]
	xor	bl,bh				;get alternative palnes
	enable_planes	bl			;set theese planes

	mov	di,[bp+6]			;di=x

	mov	bx,di
	and	bx,7				;check bit offset
	mov	dl,LEDGEMSK[bx]			;get  left  edge mask
	mov	ledge,dl

	mov	ax,[bp+10]			;ax=x1

	mov	bx,ax
	and	bx,7				;check bit offset
	mov	dl,REDGEMSK[bx]			;get  right edge mask
	mov	redge,dl

	div8	ax
	div8	di				;get left row_offset
	sub	ax,di				;ax=byte_width
	inc	ax

	mov	one_byte,0
	cmp	ax,1
	$IF	E
		mov	one_byte,1		;does  region consists of
		mov	bl,redge		;1 byte ?
		and	ledge,bl		;clip masks togather
	$ENDIF

	sub	ax,2				;get midlle width
	mov	width,ax

	mov	ax,[bp+8]			;si,di=init_offset
	mul	scr_wid
	add	di,ax
	mov	si,di
	mov	lupper_offs,di

	mov	bx,[bp+12]			;bp=height
	sub	bx,[bp+8]
	inc	bx

	mov	height,bx
	;------- replace colors at left edge...---------
	set_write_mask   ledge

	mov	dx,scr_wid
	dec	dx
	mov	cx,height
	replace_left_edge:
		movsb
		add	di,dx
		mov	si,di
	loop	replace_left_edge

	cmp	one_byte,1
	je	exit_replace_colors
	;-----------replace colors at the middle----------
	cmp	width,0				;are there any midlle byte ?
	je	replace_colors_at_redge

	set_write_mask	whole_data
	inc	lupper_offs			;points to upper left corner
	mov	di,lupper_offs			;of the midlle of the region
	mov	si,di

	mov	dx,scr_wid			;dx=row by row addition
	sub	dx,width
	mov	bp,width

	replace_midlle :			;do height times
		mov	cx,bp			;get row length
		rep	movsb			;replace one row
		add	di,dx			;advance to new row
		mov	si,di
		dec	bx			;one more row ?
	jnz	replace_midlle

	;-------replace colors at right edge--------------
	replace_colors_at_redge:

	set_write_mask	redge			;clip right edge
	mov	di,lupper_offs			;advance to right edge
	add	di,width
	mov	si,di

	mov	dx,scr_wid
	dec	dx
	mov	cx,height			; fill right edge column
	replace_right_edge:
		movsb
		add	di,dx
		mov	si,di
	loop	replace_right_edge
	;--------------------------------------------------
	exit_replace_colors:
	sti
	end_c_proc  _replace_colors ,12
;****************************************************************************
        start_c_proc    rect_fill
                push    [bp+6]
                push    [bp+8]
                push    [bp+10]
                push    [bp+12]
                call    far ptr _rect_fill
        end_c_proc      rect_fill, 8


	start_c_proc   _rect_fill
	cli					;clear interrupts
	cld					;clear  dflag

	mov	es,curr_page			;points to current vpage

	enable_planes	0fh			;enable all planes
	set_rot_logic	0,repl_
	set_wr_mode	2			; color write mode


	mov	bx,[bp+6]			;calculate start
	mov	ax,[bp+8]			;pattern offset if patterned
	call	curr_patt_offs			;filling

	mov	di,[bp+6]			;di=x
	mov	bx,di
	and	bx,7				;check bit offset
	mov	dl,LEDGEMSK[bx]			;get  left  edge mask
	mov	ledge,dl

	mov	ax,[bp+10]			;ax=x1
	mov	bx,ax

	and	bx,7				;check bit offset
	mov	dl,REDGEMSK[bx]			;get  right edge mask
	mov	redge,dl

	div8	ax
	div8	di				;get left row_offset
	sub	ax,di				;ax=byte_width
	inc	ax

	mov	one_byte,0
	cmp	ax,1
	$IF	E
		mov  one_byte,1			;does  region consist of
		mov  bl,redge			;1 byte ?
		and  ledge,bl			;clip masks togather
	$ENDIF



	sub	ax,2				;get midlle width
	mov	width,ax

	mov	ax,[bp+8]
	mul	scr_wid				;ax=yoffset
	add	di,ax				;di=initial offset

	mov	ax,[bp+12]
	mov	bx,[bp+8]
	sub	ax,bx
	inc	ax
	mov	height,ax

	cmp	draw_style,0
	$IF	NE
		call	fill_wp
	$ELSE
		call	uniform_fill
	$ENDIF


	sti
	end_c_proc	_rect_fill , 8

;-------performes uniform fill with current drawing color--------------------

	uniform_fill  proc  near

	;------- start  byte -----------------------

	set_write_mask	ledge
	mov	ah,draw_color
	mov	si,scr_wid

	mov	cx,height
	push	di				;save initial offset
	call	fill_edge_np			;fill left	edge
	pop	di				;restore initial offset

	cmp	one_byte,1
	je	exit_rect_fill
	;------ middle   --------------------------
	inc	di				;advance to next byte
	cmp	width,0				;are there any midlle byte ?
	je	uniright

	set_write_mask	whole_data
	mov	bx,width
	sub	si,bx				;si=row addition
	mov	al,draw_color			;al  contains a color

	mov	bp,height
	push	di
	unifill_mid_loop:
		mov	cx,bx			;get   width
		rep	stosb			;make  row
		add	di,si			;next  row  offset
		dec	bp
	jnz	unifill_mid_loop
	pop	di
	;-------last  ----------------------------------
	uniright:
	set_write_mask	redge
	mov	ah,draw_color
	add	di,width			;point to  right upper
	mov	si,scr_wid
	mov	cx,height
	call	fill_edge_np			;fills the edge


	exit_rect_fill:
	ret
	uniform_fill	endp

	fill_edge_np	proc	near
	er_loop:
		cmp	ah,es:[di]		;latch
		mov	es:[di],ah		;store  a color
		add	di,si			;points  to new row
	loop	er_loop
	ret
	fill_edge_np	endp


;------------this procedure fills the region with pattern 16x16
	fill_wp		proc	near

	lds	si,dword ptr pattern_latch	;ds:si to latch buffer
	point_GPX_to	8			;write mask func is only used
	mov	cx,word ptr baccolor		;set pattern colors

	mov	bx,curr_patt

	mov	cell1,0
	test	width,1
	$IF	E
		mov	cell1,1

	$ENDIF

	mov	ax,width
	mov	firstb_wid,ax			;first and second masks
	shr	ax,1				;of pattern are to be
	sub	firstb_wid,ax			;repeated when in the midlle
	mov	secndb_wid,ax			;cycle...

	cmp     width,0
	$IF	E
		mov	next_action,offset last_patt_byte
	$ELSE
		mov	next_action,offset midlle_exist
	$ENDIF

	cmp	one_byte,1
	$IF	E
		mov	next_action,offset next_row_wp16
	$ENDIF

	mov	bp,height
	;------ Main  loop is for  rows...------
	fill_wp16_row_loop:
	and	bx,01fh				;get pattern paragraph offs
	push	bx				;save di,bx for next row
	push	di
	;------ first   byte -------------------
	mov	al,ledge			;clip the edge
	out	dx,al				;set up write mask
	cmp	es:[di],cl			;latch
	mov	es:[di],cl			;set up background

	and	al,pattern[bx]			;get fg mask
	out	dx,al				;clip it with left edge
	cmp	es:[di],ch			;latch
	mov	es:[di],ch			;set up forground

	xor	bx,1				;next  pattern latch byte
	inc	di				;advance to next cell
	jmp	next_action

	;-------midlle -------------------------
	midlle_exist:
	xor	al,al				;all bits are from latch
	out	dx,al				;set current write mask

	push	di
	cmp	[bx+si],ah			;get current latch
		mov	cx,firstb_wid		;do  for first mask
		fstmsk_loop:
			stosb
			inc	di
		loop	fstmsk_loop
	pop	di


	inc	di			;advance to next screen byte
	xor	bx,1			;point to current latch
	cmp	secndb_wid,0
	je	no_secndb
		cmp	[bx+si],ah		;set current latch
		mov	cx,secndb_wid
			secmsk_loop:
				stosb
				inc	di
			loop	secmsk_loop
	no_secndb:


	mov	cx,word ptr baccolor		;restore  colors
	;-------last byte ----------------------
	xor	bx,cell1
	sub	di,cell1

	last_patt_byte:
	mov	al,redge			;for left edge
	out	dx,al
	cmp	es:[di],cl
	mov	es:[di],cl

	and	al,pattern[bx]			;get fg mask
	out	dx,al
	cmp	es:[di],ch
	mov	es:[di],ch

	next_row_wp16:
	pop	di				;get a head of the row
	pop	bx				;restore head paragraph offs
	add	di,scr_wid			;advance to next row
	add	bx,2				;update paragraph offset

	dec	bp				;one more row ?
	jnz	fill_wp16_row_loop


	ret
	fill_wp		endp


        start_c_proc   copy_region
                push    [bp+6]
                push    [bp+8]
                push    [bp+10]
                push    [bp+12]
                push    [bp+14]
                push    [bp+16]
                call    far ptr _copy_region

        end_c_proc     copy_region , 12


	start_c_proc	_copy_region
	cli					;clear interrupts
	mov	alter_planes,0fh
	call	w0_data_planes
	set_wr_mode	0			;set write-read mode
	mov	ds,curr_page			;points to current page
	mov	es,curr_page

	mov	ax,[bp+12]			;define height of the region
	sub	ax,[bp+8]
	inc	ax
	mov	height,ax

	mov	ax,[bp+10]			;get x of rightmost point
	mov	bx,ax                           ;of the destination
	add	bx,[bp+14]
	sub	bx,[bp+6]
	mov	cx,bx				;save for next use

	mov	ax,[bp+14]
	div8	ax				;get width of the midlle of
	div8	bx				;the destination region
	sub	bx,ax				;in bytes
	inc	bx
	mov	width,bx

	mov	bx,[bp+14]			;calculates first and
	and	bx,7				;second masks assuming
	mov	bl,LEDGEMSK[bx]			;that direction is forward
	mov	fst_edge,bl
	mov	bx,cx
	and	bx,7
	mov	bl,REDGEMSK[bx]
	mov	sec_edge,bl

	mov	ax,[bp+6]			;define wich horizontal
	mov	bx,[bp+14]			;copy direction is needed
	cmp	ax,bx				;if less or equal copy in
	jle	copy_bw_dir			;forward direction
	;---------------------------------
		cld				;clear direction flag
		mov	si,ax			;get source and destination
		mov	di,bx			;xoffs
		div8	si
		div8	di

		and	ax,7			;define wich shift is on
		and	bx,7			;relatively to copy direction
		sub	bx,ax			;compare left edge positions
		jg	fw_r_shf		;if g.e then right shift
		je	fw_no_shf
		neg	bx			;get shift count
		mov	rot_counter,8
		sub	rot_counter,bl
		mov	cl,REDGEMSK[bx-1]	;else fw left shift
		mov	ch,cl
		not	ch

		jmp	copy_horiz_dir_ok
		fw_no_shf:
			mov	rot_counter,0
			mov	cl,0ffh
			mov	ch,0
			dec	si
		jmp	copy_horiz_dir_ok

		fw_r_shf:
			mov	rot_counter,bl
			mov	ax,7
			sub	ax,bx
			mov	bx,ax
			mov	cl,REDGEMSK[bx]
			mov	ch,cl
			not	ch
			dec	si
		jmp	copy_horiz_dir_ok
		;---------------------------------
		copy_bw_dir :			;else copy in backward  dir
		std				;store direction flag

		mov	dl,fst_edge		;backward direction reverse
		xchg	dl,sec_edge		;edges...
		mov	fst_edge,dl

		mov	si,[bp+10]		;get source and destination
		mov	di,cx			;xoffs
		div8	si
		div8	di

		mov	ax,[bp+10]		;define wich shift is on
		mov	bx,cx
		and	ax,7
		and	bx,7
		sub	bx,ax
		jg	bw_r_shf		;if less then right shift
		je	bw_no_shf

		neg	bx			;set shift count
		mov	rot_counter,8
		sub	rot_counter,bl
						;some secret action
		mov	ch,REDGEMSK[bx-1]	;( see copy documentation )
		mov	cl,ch
		not	cl
		inc	si
		jmp	copy_horiz_dir_ok
		bw_no_shf:
		mov	rot_counter,0
		mov	cl,0ffh
		mov	ch,0
		inc	si
		jmp	copy_horiz_dir_ok
		bw_r_shf:			;else fw left shift

			mov	rot_counter,bl
			sub	bx,7
			neg	bx
			mov	ch,REDGEMSK[bx]
			mov	cl,ch
			not	cl
		;-------------------------------
		copy_horiz_dir_ok:

		mov	dx,scr_wid
		mov	row_add,dx
		mov	ax,[bp+8]
		mov	bx,[bp+16]
		cmp	ax,bx			;is upward direction needed ?
		$IF	LE
			neg	row_add
			mov	ax,[bp+12]	;source  y1
			add	bx,ax		;bx contains destination
			sub	bx,[bp+8]	;first point y
		$ENDIF

	mul	scr_wid				;calculate source and
	add	si,ax				;destination initial
	mov	ax,bx				;offsets
	mul	scr_wid
	add	di,ax
	set_rot_logic	rot_counter,repl_	;set number to rotate
	sub	width,2				;get width of the midlle

	;-------do for every row-----------------
	copy_row_loop:
		mov	bl,8			;set initial plane value
		mov	read_plane,3		;for read and write

		;-----do for each plane --------
		copy_plane_loop:
		mov	dx,03c4h		;enable write to current
		mov	al,2			;plane using the sequencer
		out	dx,al
		inc	dx
		mov	al,bl
		out	dx,al

		mov	dx,03ceh		;enable read from current
		mov	al,4			;plane using graphics contr
		out	dx,al
		inc	dx			;sorry for digits.
		mov	al,read_plane		;if use GPX,SEQ
		out	dx,al			;cycle upgrows 127 bytes

		dec	dx			;points GPX to write mask
		mov	al,8			;function
		out	dx,al
		inc	dx

		push	si			;store for next usage
		push	di

		lodsb				;get very first byte
		mov	ah,al			;set very first byte (v.f.b)
		;============== first byte ===========================
		mov	al,fst_edge		;clip first edge
		out	dx,al			;set write mask
		lodsb				;get source byte
		mov	bh,al			;save
		and	ax,cx     		;clip first and sec masks
		or	al,ah			;construct a cell
		cmp	al,es:[di]		;latch to preserve backg
		stosb				;set with rotation
		mov	ah,bh			; update 'previous byte'
		;============== midlle bytes =========================
		mov	al,0ffh			;all bits are from data
		out	dx,al			;set write mask
		mov	bp,width		;do width times
		copy_in_row_loop:
			lodsb			;get source byte
			mov	bh,al		;save
			and	ax,cx		;cut parts
			or	al,ah		;construct current cell
			stosb			;copy current cell
			mov	ah,bh		;store as old byte
			dec	bp		;one more row ?
		jnz	copy_in_row_loop
		;===== last byte =====================================
		mov	al,sec_edge		;clip second edge
		out	dx,al			;set write mask
		mov	al,[si]			;get current byte
		and	ax,cx			;clip with first part
		or	al,ah			;construct current cell
		xchg	al,es:[di]		;latch to preserve backg
						;and store current byte
						;Here is the elegancy of Ega!
		;=====================================================
		pop	di
		pop	si
	dec	read_plane			;update current read  plane
	shr	bl,1				;update current write plane
	jnc	copy_plane_loop			;one more plane ?
	;---------------------------------------

	add	si,row_add			;advance to new row at
	add	di,row_add			;source and destination

	dec	height				;one more row ?
	jnz	copy_row_loop
	;---------------------------------------
	sti
	end_c_proc	_copy_region ,12


;***************************************************************************
        start_c_proc    save_region
                push    [bp+8]
                push    [bp+6]
                push    [bp+12]
                push    [bp+10]
                push    [bp+16]
                push    [bp+14]
                push    [bp+20]
                push    [bp+18]
                push    [bp+22]
                push    [bp+24]
                push    [bp+26]
                push    [bp+28]
                push    [bp+30]
                call    far ptr _save_region

        end_c_proc      save_region ,26


	start_c_proc	_save_region
	cli
	cld
	mov	alter_planes,0fh
	call	w0_data_planes
	set_wr_mode	0			;w0r0 ega mode
	set_rot_logic	0,repl_			;rotation=0,and replace log

	mov	di,[bp+8]			;get width of a region
	mov	bx,di
	and	bx,7
	mov	bl,LEDGEMSK[bx]
	mov	ledge,bl

	mov	ax,[bp+12]
	mov	bx,ax
	and	bx,7
	mov	bl,REDGEMSK[bx]
	mov	redge,bl

	div8	di				;di contains offset in a row
	div8	ax
	sub	ax,di
	inc	ax
	mov	width,ax

	mov	cx,scr_wid                             ; calculate  row by row
	sub	cx,width                               ; offset addition
	mov	row_add,cx

	mov	ax,[bp+10]                             ; get height of the region
	mov	bx,[bp+14]                             ; and offset of the upper
	sub	bx,ax                                  ; left corner of the region
	inc	bx
	mov	height,bx
	mul	scr_wid
	add	di,ax
	mov	lupper_offs,di

	add	bp,16                                  ; bp points to 3td plane buff
	cmp	byte ptr [bp-10],0                     ; wich action is called ?
	je	restore
	;----------------------------------------
	store:
	mov	ds,curr_page
	point_GPX_to	4			;point to read plane func
	mov	al,3				;set initial read plane

	store_plane_loop:			;do for current plane
		out	dx,al			;set current read plane
		mov	si,lupper_offs		;si points to upper left crnr
		les	di,dword ptr [bp]	;es:di points to plane buffer

		mov	bx,height		;do for each row height times
		store_row_loop:			;store a row ...
		mov	cx,width
		rep	movsb
		add	si,row_add		;points next row
		dec	bx			;one more row ?
		jnz	store_row_loop

		add	bp,4			;points to new plane buffer
		dec	al			;update current plane index
		jns	store_plane_loop	;one more plane ?

	jmp	save_reg_exit
	;---------------------------------------
	restore:
	mov	es,curr_page
	mov	di,lupper_offs
	mov	bx,width
	cmp	bx,1
	$IF	E
		mov	next_action,offset restore_next_row
		mov	al,redge
		and	ledge,al
	$ELSE
		sub	bx,2			;clip the midlle
		$IF	Z			;does any midlle bytes exist?
			mov	next_action,offset restore_last_byte
		$ELSE
			mov	next_action,offset restore_midlle
		$ENDIF
	$ENDIF

	restore_row_loop:			;restore row by row ...
	mov	curr_plane,8
	restore_plane_loop:			;restore row plane by plane
		push	di			;store row head
		lds	si,dword ptr [bp]	;ds:si points to curr buffer
		enable_planes	curr_plane

		set_write_mask	ledge		;set leftmost byte
		cmp	es:[di],ah
		movsb
		inc	word ptr [bp]		;update buffer frame
		jmp	next_action

	restore_midlle:
		set_write_mask	0ffh
		mov	cx,bx			;get row length
		rep	movsb			;restores one plane row
		add	[bp],bx			;update buffer frame
	restore_last_byte:
		set_write_mask	redge
		cmp	es:[di],ah
		movsb
		inc	word ptr [bp]		;update buffer frame
	restore_next_row:
		pop	di			;return to row head
		add	bp,4			;points to new plane buffer
	shr	curr_plane,1			;update current write plane
	jnc	restore_plane_loop		;one more plane ?

	add	di,scr_wid			;points new screen row
	sub	bp,16				;return to 3td plane buffer
	dec	height				;one more row ?
	jnz	restore_row_loop

	save_reg_exit:
	sti
	end_c_proc	_save_region ,26

	;*****************************************************************
;******************************************************************************

        start_c_proc    set_text_color
                push    [bp+6]
                push    [bp+8]
                call    far ptr _set_text_color
        end_c_proc      set_text_color ,4


	start_c_proc	_set_text_color
		enable_planes	0ffh
		set_write_mask	0ffh
		set_wr_mode	2
		set_rot_logic	0,repl_

		mov	al,[bp+6]
		mov	textcolor,al
		mov	bl,[bp+8]
		mov	textbcolor,bl
		lds	si,dword ptr color_cell
		mov	[si],bl
		xor	bl,al
		mov	icon_alter_planes,bl
	end_c_proc	_set_text_color , 4


        start_c_proc    put_icon
                push    [bp+6]
                push    [bp+8]
                push    [bp+10]
                push    [bp+12]
                push    [bp+16]
                push    [bp+14]
                call    far ptr _put_icon

        end_c_proc      put_icon , 12

	start_c_proc	_put_icon
	cli
	cld					;forward direction
	enable_planes	0fh

	mov	al,icon_alter_planes
	mov	alter_planes,al

	call	w0_data_planes
	mov	es,curr_page			;es:di to screen location

	mov	ax,[bp+14]
	dec	ax
	div8	ax
	inc	ax
	mov	byte_width,ax


	push	[bp+16]
	pop	height

	mov	ax,[bp+12]			;get yoffset
	mul	scr_wid

	mov	si,[bp+10]			;si=x of leftmost point
	mov	bx,si
	div8	si				;get initial offset
	add	si,ax
	mov	lupper_offs,si
	and	bx,7
	mov	cl,LEDGEMSK[bx]			;left edge clipping mask
	mov	ledge,cl

	mov	cx,7
	sub	cx,bx
	mov	rot_counter,bl			;cx=bx
	mov	bx,cx				;bx=7-bx

	mov	cl,REDGEMSK[bx]			;calculate edges before
	mov	left_part,cl			;rotation
	not	cl				;to move appropreately
	mov	right_part,cl			;when rotate

	mov	di,[bp+10]
	add	di,[bp+14]
	dec	di				;di=x of rightmost point
	mov	bx,di
	div8	di
	add	di,ax
	mov	rupper_offs,di
	and	bx,7
	mov	cl,REDGEMSK[bx]			;right edge clipping mask
	mov	redge,cl


	;set up pointer to skip if midlle is doomy,or to get midlle width
	;otherwise


	sub	di,si				;get left-right offs difference
	lds	si,dword ptr [bp+6]		;point to icon storage
	mov	icon_start,si

	cmp	di,0
	$IF	Z
		mov	bl,redge
		and	bl,ledge
		mov	redge,bl
		mov	width,0
		jmp	icon_redge
	$ELSE
		cmp	di,1
		$IF	E
			mov	width,0
			jmp	icon_ledge
		$ELSE
			dec	di
			mov	width,di
			push	scr_wid
			pop	row_add
			sub	row_add,di
			jmp	icon_midlle
		$ENDIF
	$ENDIF

	;-------store midlle of the icon---------
	icon_midlle:
	set_wr_mode	0
	set_rot_logic	rot_counter,xor_
	set_write_mask	whole_data


	les	di,dword ptr color_cell		;loads latch with background
	cmp	es:[di],al

	mov	es,curr_page
	mov	di,lupper_offs

	inc	di				;si points to current byte

	mov	cx,word ptr left_part		;cl=right mask ch=left one
	mov	dx,row_add

	push	height
	pop	row_counter
	icon_mid_row_loop:
		push	si
		mov	ah,[si]			;first 'old' byte
		inc	si			;and point to next byte
		mov	bp,width
		icon_in_row:
			lodsb
			mov	bh,al		;save
			and	ax,cx		;clip parts
			or	al,ah		;construct a cell
			stosb			;store at screen
			mov	ah,bh		;update 'old' byte
			dec	bp
		jnz	icon_in_row
		add	di,dx			;advance to next screen row
		pop	si
		add	si,byte_width		;skip to next
		dec	row_counter
	jnz	icon_mid_row_loop

	;-------set icon right edge-------------
	icon_ledge:
		set_wr_mode	2
		set_rot_logic	0,repl_
		set_write_mask	ledge

		mov	dx,scr_wid
		mov	di,lupper_offs

		mov	bp,height
		mov	bl,textbcolor
		icon_ledge_bg_loop:		;fill left edge with background
			cmp	es:[di],bl	;latch
			mov	es:[di],bl	;background pixels
			add	di,dx
		dec	bp
		jnz	icon_ledge_bg_loop

		mov	si,icon_start
		set_wr_mode	0
		set_rot_logic	rot_counter,xor_
		call	w0_data_planes

		mov	dx,scr_wid
		mov	di,lupper_offs
		mov	bp,height
		icon_ledge_fg_loop:		;set up pixels
			mov	bl,[si]
			cmp	es:[di],bl
			mov	es:[di],bl
			add	di,dx
			add	si,byte_width
		dec	bp
		jnz	icon_ledge_fg_loop
	;-------set icon left edge--------------
	icon_redge:
		set_wr_mode	2
		set_rot_logic	0,repl_
		set_write_mask	redge

		mov	si,icon_start
		add	si,byte_width
		dec	si
		mov	dx,scr_wid
		mov	di,rupper_offs
		mov	bp,height
		mov	bl,textbcolor
		icon_redge_bg_loop:
			cmp	es:[di],bl      ;fill redge with background
			mov	es:[di],bl
			add	di,dx
		dec	bp
		jnz	icon_redge_bg_loop

		set_wr_mode	0
		set_rot_logic	rot_counter,xor_

		mov	si,icon_start
		add	si,width		;it is very important
						;that width is presented here
		inc	si			;point to predleftmost byte
		mov	cx,word ptr left_part


		mov	dx,scr_wid
		mov	di,rupper_offs
		mov	bp,height
		icon_redge_fg_loop:		;set up pixels
			mov	ah,[si-1]
			mov	al,[si]		;get 2 bytes
			and	ax,cx		;clip right left part
			or	al,ah		;construct cell
			cmp	es:[di],al
			mov	es:[di],al
			add	di,dx
			add	si,byte_width
		dec	bp
		jnz	icon_redge_fg_loop

	put_icon_exit:
	sti
	end_c_proc	_put_icon , 12


        start_c_proc    read_byte_block
                push    [bp+6]
                push    [bp+8]
                push    [bp+10]
                push    [bp+12]
                push    [bp+16]
                push    [bp+14]
                call    far ptr _read_byte_block
        end_c_proc      read_byte_block  ,12


	start_c_proc	_read_byte_block
	cli
	cld
	set_wr_mode	0
	mov	ds,curr_page
	les	di,dword ptr [bp+6]		;get buffer address
	mov	buffer_offs,di


	mov	ax,[bp+16]
	mov	bx,[bp+12]
	sub	ax,bx
	inc	ax
	mov	height,ax

	mov	ax,[bp+14]
	mov	bx,[bp+10]
	sub	ax,bx
	inc	ax
	mov	width,ax

	dec	ax
	mul	height				;get buffer volume
	mov	cx,ax
	xor	al,al
		rep	stosb			;clears the buffer

	mov	cx,height
		rep	stosb


	mov	ax,[bp+12]
	mul	scr_wid				;compute yoffset
	mov	si,[bp+10]
	div8	si
	add	si,ax				;si points to first byte
	mov	lupper_offs,si

	mov	bx,[bp+10]			;calculate start bit mask
	and	bx,7
	mov	al,BMASKS[bx]
	mov     ledge,al

	mov	ax,[bp+10]			;calculates byte_width of
	mov	bx,[bp+14]                      ;the region and row by row add
	div8	bx
	div8	ax
	sub	bx,ax
	inc	bx
	mov	byte_width,bx

	mov	ax,scr_wid
	sub	ax,bx
	mov	row_add,ax


	mov	dx,GPX_IR			;prepare for read plane func
	mov	al,4
	out	dx,al

	mov	read_plane,3			;set plane to read
	mov	ah,8				;initial plane update value
	read_plane_loop:
	mov	al,read_plane
	mov	dx,GPX_DR
	out	dx,al				;set current read plane

	mov	si,lupper_offs
	mov	di,buffer_offs

	mov	bp,height
	read_plane_row_loop:
	mov	bl,ledge        	;start up with initial mask
	mov	cx,width
	push	si
	lodsb
	read_plane_col_loop:
		test	bl,al			;test for plane value of pixel
		$IF	NZ
			add	es:[di],ah	;update current pixel byte
		$ENDIF
		ror	bl,1			;update pixel location
		$IF	C               	;if overflows byte
			lodsb
		$ENDIF
		inc	di			;advance to new buffer cell
	loop	read_plane_col_loop
	pop	si
	add	si,scr_wid
	dec	bp			;one more row ?
	jnz	read_plane_row_loop

	dec	read_plane
	shr	ah,1
	jnc     read_plane_loop

	sti
	end_c_proc	_read_byte_block ,12

;*****************************************************************************
        start_c_proc    write_byte_block
                push    [bp+6]
                push    [bp+8]
                push    [bp+10]
                push    [bp+12]
                push    [bp+16]
                push    [bp+14]
                call    far ptr _write_byte_block
        end_c_proc      write_byte_block  ,12



	start_c_proc	_write_byte_block
	cli
	cld
	mov	alter_planes,0ffh
	call	w0_data_planes


	enable_planes	0fh
	set_rot_logic	0,repl_

	set_wr_mode	2
	mov	es,curr_page
	lds	si,dword ptr [bp+6]
	mov	curr_buff,si

	mov	ax,[bp+16]
	mov	bx,[bp+12]
	sub	ax,bx
	inc	ax
	mov	height,ax

	mov	ax,[bp+14]
	mov	bx,[bp+10]
	sub	ax,bx
	inc	ax
	mov	width,ax

	mov	ax,[bp+12]
	mul	scr_wid				;compute yoffset
	mov	si,[bp+10]
	div8	si
	add	si,ax				;si points to first byte
	mov	curr_cell,si			;upper left offset

	mov	ax,[bp+10]			;calculates byte_width of
	mov	bx,[bp+14]                      ;the region and row by row add
	div8	bx
	div8	ax
	sub	bx,ax
	inc	bx
	mov	byte_width,bx

	mov	ax,scr_wid
	sub	ax,bx
	mov	row_add,ax

	mov	bx,[bp+10]			;calculate start bit mask
	and	bx,7
	add	curr_buff,8			;start up position at the buff
	sub	curr_buff,bx
	mov	al,BMASKS[bx]
	mov     ledge,al

	mov	bx,[bp+14]			;calculate start bit mask
	and	bx,7
	mov	al,BMASKS[bx]
	mov     redge,al

	point_GPX_to	8			;write mask function is used

	mov	ch,byte ptr byte_width		;number of bytes wich contain
	dec	ch				;pixel with this mask
	inc	curr_cell

	mov	al,080h				;initial mask
	write_block_mask_loop:

	cmp	al,ledge                ;if mask overflow ledge
	$IF	E			;include leftmost byte
		dec	curr_cell
		sub	curr_buff,8
		inc	ch
	$ENDIF

	out	dx,al			;set up current write mask
	mov	si,curr_buff
	mov	di,curr_cell

	cmp	ch,0
	$IF	NE
		mov	bp,height		;do height times
		write_mask_row_loop:
		mov	cl,ch
		push	si
		push	di

		write_mask_column_loop:
			cmp	es:[di],ah	;latch
			movsb			;set pixel
			add	si,7		;advance to next buffer cell
			dec	cl              ;update counter
		jnz	write_mask_column_loop

		pop	di
		pop	si
		add	di,scr_wid
		add	si,width		;advance to new buffer row

		dec	bp
		jnz	write_mask_row_loop
	$ENDIF

	cmp	al,redge
	$IF	E
		dec	ch
	$ENDIF

	inc	curr_buff		;start up with next buffer byte
	shr	al,1			;update current mask
	jnc	write_block_mask_loop

	sti
	end_c_proc	_write_byte_block ,12

;*****************************************************************************
;	This procedure is used to transfer content of the 2nd page to
;	the 1st page.Parameter is used to vary  transfer style.





	start_c_proc		transffer_page
	cli
	cld
	mov	sp_store,sp
	enable_planes		0ffh
	set_wr_mode		1

	mov	al,[bp+6]
	mov	transffer_delay,al

	mov	es,first_page			;set up initial addresses
	mov	ds,second_page

	mov	bx,[bp+8]			;get step parameter
	xor	dx,dx
	mov	ax,plane_size
	div	bx
	mov	bp,0				;initial step start

	xor	dh,dh

	;do   for  current  step  start
	mov	sp,bx
	mov	bx,ax
	dec	ax
	step_trans_loop:
		mov	si,bp			;points to step start
		mov	di,bp
		mov	cx,sp
		current_step_loop:
			movsb			;update current byte
				mov	dl,transffer_delay
				delay_loop:
					nop
				dec	dx
				jnz	delay_loop
			add	si,ax		;advance to next byte
			add	di,ax
		loop	current_step_loop

		inc	bp			;update step start position
	dec	bx				;one more step loop ?
	jnz	step_trans_loop

	mov	cx,dx				;get remainder
	rep	movsb				;update last step
	mov	sp,sp_store

	sti
	end_c_proc		transffer_page ,4



	set_current_page	proc	far
		push	bp
		mov	bp,sp
		mov	ax,first_page

		cmp	byte ptr [bp+6],0
		je	fir_page
			mov	ax,second_page
		fir_page:
		mov	curr_page,ax

		pop	bp
		ret     2
	set_current_page	endp


	set_font	proc	far
		push	bp
		mov	bp,sp
		push	[bp+6]
		pop	char_set_base
		push	[bp+8]
		pop	char_set_base+2
		pop	bp
		ret     4
	set_font	endp

	set_char_cell	proc	far
		push	bp
		mov	bp,sp
		push	[bp+10]
		pop	char_height
		push	[bp+8]
		pop	startline
		push	[bp+6]
		pop	vdots
		pop	bp
		ret     6
	set_char_cell	endp


	set_draw_color		proc		far
		push	bp
		mov	bp,sp
		mov	al,[bp+6]
		mov	draw_color,al
		pop	bp
		ret     2
	set_draw_color		endp


	set_draw_style		proc		far
		push	bp
		mov	bp,sp
		mov	al,[bp+6]
		mov	draw_style,al
		pop	bp
		ret     2
	set_draw_style		endp


	set_line_logic		proc		far
		push	bp
		mov	bp,sp
		mov	al,[bp+6]
		mov	line_logic,al
		pop	bp
		ret     2
	set_line_logic		endp

	set_text_style		proc		far
		push	bp
		mov	bp,sp
		mov	al,[bp+6]
		mov	text_style,al
		pop	bp
		ret     2
	set_text_style		endp

        start_c_proc    put_string
                lds     si,dword ptr [bp+10]
                les     di,dword ptr [bp+10]

                inc     si

                cld

                xor     cx,cx
                mov     cl,byte ptr es:[di]
                mov     str_len,cl
                rep     movsb

                xor     ax,ax
                mov     byte ptr es:[di],al

                push    [bp+6]
                push    [bp+8]
                push    [bp+12]
                push    [bp+10]
                call    far ptr _put_string

                lds     si,dword ptr [bp+10]
                les     di,dword ptr [bp+10]

                xor     ax,ax
                mov     al,str_len
                add     si,ax
                add     di,ax
                dec     si

                std

                xor     cx,cx
                mov     cl,str_len

                rep     movsb

                mov     al,str_len
                mov     byte ptr es:[di],al

        end_c_proc      put_string,8



	start_c_proc	_put_string
	cli
	cld
	enable_planes	0fh			;enable all planes to modify

	mov	es,curr_page
	mov	ax,[bp+10]			;calculates pattern start offs
	mov	bx,[bp+12]
	call	curr_patt_offs

	mov	ax,[bp+12]			;ax=y
	mul	scr_wid				;ax=yoffs
	mov	di,[bp+10]			;di=x
	mov	bx,di				;store for next  use
	div8	di
	add	di,ax				;set  start screen offset

	and	bx,7				;get  bit position
	mov	rot_counter,bl			;number to rotate when nba

	mov	al,LEDGEMSK[bx]			;calculate edge clipping msks
	mov	ledge,al
	not	al
	mov	redge,al

	mov	ax,7
	sub	ax,bx
	mov	cx,bx				;cx=bx
	mov	bx,ax				;bx=7-bx

	mov	al,REDGEMSK[bx]			; calculate edges before
	mov	left_part,al			; rotation
	not	al				; to move appropreately
	mov	right_part,al			; when rotate

	mov	bx,word ptr textcolor
	xor	bl,bh
	mov	alter_planes,bl

	lds	si,dword ptr [bp+6]		;ss:bp will point to string
	mov	curr_char,si
	mov	string_seg,ds                   ;store string segment
	mov	ss_store,ss                     ;store stack segment
	mov	curr_cell,di			;save upper left offset

	mov	bx,offset patterned_string
	cmp	text_style,0			;is this a byte aligned case?
	je	solid_string
	jmp	bx
	solid_string:
		cmp	cl,0
			$IF	NE
			jmp	string_nba
		$ENDIF
	;===========  Uniform  byte aligned=====================
	string_ba:
	set_write_mask	0ffh			;all bits are from data
	set_rot_logic	0,018h			;rotation=0 logic=xor
	set_wr_mode	0
	call	w0_data_planes		;alterative bit planes

	mov	ss,string_seg			;ss:bp points to screen
	lds	si,dword ptr color_cell		;latch is loaded with
	cmp	[si],al				;text background
	mov	ds,char_set_base+2		;get character table segment

	mov	dx,scr_wid
	dec	dx
	mov	bp,curr_char

	char_by_char_ba:
	mov	al,[bp]				;get char  code
	or	al,al				;is this a terminate char ?
	je	exit_string_ba
	one_more_char:
		mov	si,char_set_base	;points to  start of ch_tbl
		mul	byte ptr char_height		;si points to current char
		add	si,ax			;at the char table
		add	si,startline
		mov	di,curr_cell		;points to next screen cell
		mov   cx,vdots			;get number off  rows
		uba_char_loop:
			movsb			;set  character  line
			add	di,dx		;dx=scr_wid-1;
		loop	uba_char_loop		;one more line ?
		inc	bp			;update string ptr
		inc	curr_cell			;advance to next one
	jmp	char_by_char_ba

	exit_string_ba:
	jmp	put_string_exit
	;----------------------------------------
	;=======Non-byte aligned case============
	string_nba:
	lds	si,dword ptr char_set_base
	mov	ss,string_seg
	mov	bp,curr_char

	mov	al,[bp]				;al has char code
	or	al,al				;is this a doomy string ?
	jne	non_doomy_string_nba
	jmp	put_string_exit
	non_doomy_string_nba:

	mul	byte ptr char_height		;calculate character start
	add	si,ax				;position at the table
	add	si,startline			;advance to start line

	;-------Start  up  with  the first character
	mov	ss,ss_store			;restore stack segment
						;to use procedure calls
	set_wr_mode	2			;set color write mode
	set_rot_logic	0,repl_			;set replace logic
	point_GPX_to	8			;point to write mask function

	mov	prevch_ptr,si			;save previous character ptr
	mov	bp,scr_wid
	mov	bx,word ptr textcolor

	mov	ah,ledge

	mov	cl,rot_counter
	mov	ch,byte 	ptr vdots
	first_char_loop:			;set  character row by row
		mov	al,ah
		out	dx,al			;set current mask
		cmp	es:[di],bh		;latch
		mov	es:[di],bh		;set background

		lodsb				;get current line of character
		ror	al,cl			;assume bit shift
		and	al,ah			;clip  left edge
		out	dx,al			;set up current mask

		cmp	es:[di],bl		;latch
		mov	es:[di],bl		;set forground pixels
		add	di,bp			;advance to new row
		dec	ch
	jnz	first_char_loop			;one more row ?
	;-------- midlle characters are set using xor-technique
	set_wr_mode	0
	set_rot_logic	rot_counter,xor_
	set_write_mask	whole_data		;all bits are from data
	call	w0_data_planes

	mov	ss,string_seg			;ss:[bp] points to string
	mov	dx,word ptr left_part		;dl,dh contains right and left

	lds	si,dword ptr color_cell		;latch is loaded with
	cmp	[si],al				;text background
	mov	ds,char_set_base+2		;get character table segment

	;stack cann't be used here because ss:bp points to string now!
	char_by_char_nba  :
	mov	bx,prevch_ptr			;get previous character ptr
	inc	curr_cell				;advance to next screen cell
	inc	curr_char				;update string pointer
	mov	di,curr_cell			;get screen cell
	mov	bp,curr_char			;get string pointer

	mov	al,[bp]				;get char code
	or	al,al				;is this a terminate char ?
	je	last_char			;yes,go to exit

		mov	si,char_set_base	;points to start of ch_tbl
		mul	byte ptr char_height	;point to  position at chtb
		add	si,ax
		add	si,startline		;begin with start line
		mov     prevch_ptr,si		;save as previous character

		mov	bp,scr_wid
		mov	cx,vdots		;cx=vdots
		row_by_row_mid	:		;set  a character row by row
			mov	ah,[bx]		;get previous character line
			lodsb			;get  current  character line
			and	ax,dx
			or	al,ah		;construct a cell
			mov	es:[di],al	;set pixels with rotation
			add	di,bp		;advance to next screen row
			inc	bx		;update previous char line ptr
		loop  row_by_row_mid
	jmp	char_by_char_nba		;draw next char
	;----------- and now last character right part
	last_char:
	mov	ss,ss_store			;restore stack
	set_wr_mode	2
	set_rot_logic	0,repl_
	point_GPX_to	8			;point to write mask function

	mov	si,prevch_ptr
	mov	bx,word ptr textcolor
	mov	bp,scr_wid

	mov	ah,redge
	mov	cl,rot_counter
	mov	ch,byte ptr vdots		;cx=vdots
	last_char_loop:				;set  character row by row
		mov	al,ah			;clip right edge
		out	dx,al			;set current mask
		cmp	es:[di],bh		;latch
		mov	es:[di],bh		;set background pixels
		lodsb				;get current line of character
		ror	al,cl			;assume that bit shift exist
		and	al,ah			;clip with left edge
		out	dx,al			;set up current mask
		cmp	es:[di],bl		;latch
		mov	es:[di],bl		;set forground pixels
		add	di,bp			;advance to new row
		dec	ch
	jnz	last_char_loop			;one more row ?
	;----------------------------------------
	patterned_string:
	cmp	cl,0
	$IF	NE
		jmp	string_nba_patt
	$ENDIF

	;===========  byte aligned patterned
	string_ba_patt:
	set_write_mask	0ffh			;all bits are from data
	set_rot_logic	0,018h			;rotation=0 logic=xor
	set_wr_mode	0
	call	w0_data_planes		;alterative bit planes
	mov	bp,curr_char

	mov	ss,string_seg			;ss:bp points to screen
	lds	si,dword ptr color_cell		;latch is loaded with
	cmp	[si],al				;text background
	mov	ds,char_set_base+2		;get character table segment

	mov	dx,scr_wid
	dec	dx

	char_by_char_ba_p:
	mov	al,[bp]				;get char  code
	or	al,al				;is this a terminate char ?
	je	exit_string_ba_p
	one_more_char_p:
		mov	bx,curr_patt
		mov	si,char_set_base	;points to  start of ch_tbl
		mul	byte ptr char_height	;si points to current char
		add	si,ax			;at the char table
		add	si,startline
		mov	di,curr_cell		;points to next screen cell
		mov	cx,vdots		;get number off  rows
		uba_char_loop_p:
			lodsb			;get character line
			and	al,textpattern[bx]
			stosb			;set current line
			add	bx,2		;go to new pattern row
			and	bx,01fh		;get pattern paragraph offs
			add	di,dx		;dx=scr_wid-1;
		loop	uba_char_loop_p		;one more line ?
		inc	bp			;update string ptr
		inc	curr_cell		;advance to next one
		xor	curr_patt,1		;update current pattern
	jmp	char_by_char_ba_p

	exit_string_ba_p:
	jmp	put_string_exit
	;=======Non-byte aligned pattened case============
	string_nba_patt:
	mov	ss,string_seg
	mov	bp,curr_char
	mov	al,[bp]				;al has char code
	or	al,al			;is this a doomy string ?
	jne	non_doomy_string_nba_p
	jmp	put_string_exit

	non_doomy_string_nba_p:
	lds	si,dword ptr char_set_base	;point to character table
	;-------Start  up  with  the first character
	mul	byte ptr char_height		;calculate character start
	add	si,ax				;position at the table
	add	si,startline
	mov	prevch_ptr,si			;save previous character ptr
	mov	bx,curr_patt			;get initial pattern
	mov	ss,ss_store			;restore stack segment
						;to use procedure calls
	set_wr_mode	2			;set color write mode
	set_rot_logic	0,repl_			;set replace logic
	point_GPX_to	8			;point to write mask function

	mov	ah,ledge
	mov	ch,byte ptr vdots
	first_char_loop_p:			;set  character row by row
		mov	al,ah
		out	dx,al			;set current mask
		cmp	es:[di],bh		;latch
		mov	al,textbcolor
		mov	es:[di],al		;set background
		lodsb				;get current line of character
		ror	al,cl			;assume bit shift
		and	al,ah			;clip  left edge
		and	al,textpattern[bx]	;assume pattern
		out	dx,al			;set up current mask
		cmp	es:[di],bl		;latch
		mov	al,textcolor
		mov	es:[di],al		;set forground pixels
		add	di,scr_wid		;advance to new row
		add	bx,2			;next pattern row
		and	bx,01fh			;pattern paragraph offs
		dec	ch
	jnz	first_char_loop_p		;one more row ?
	;-------- midlle characters are set using xor-technique
	set_wr_mode	0
	set_rot_logic	0,xor_
	set_write_mask	whole_data		;all bits are from data
	call	w0_data_planes

	mov	ss,string_seg			;ss:[bp] points to string
	mov	dx,word ptr left_part		;dl,dh contains right and left

	lds	si,dword ptr color_cell		;latch is loaded with
	cmp	[si],al				;text background
	mov	ds,char_set_base+2		;get character table segment

	;stack cann't be used here because ss:bp points to string now!
	char_by_char_nba_p :
	inc	curr_cell			;advance to next screen cell
	inc	curr_char			;update string pointer
	xor	curr_patt,1			;adjaicent pattern byte
	mov	di,curr_cell			;get screen cell
	mov	bx,curr_patt			;set current pattern
	mov	bp,curr_char			;get string pointer

	mov	al,[bp]				;get char code
	or	al,al				;is this a terminate char ?
	je	last_char_p			;yes,go to exit
		mov	bp,prevch_ptr
		mov	si,char_set_base	;points to start of ch_tbl
		mul	byte ptr char_height	;point to  position at chtb
		add	si,ax
		add	si,startline		;begin with start line
		mov     prevch_ptr,si		;save as previous character

		mov	ch,byte	ptr vdots	;cx=vdots
		row_by_row_mid_p:		;set  a character row by row
			mov	ah,ds:[bp]	;get previous character line
			lodsb			;get  current  character line
			and	ax,dx
			or	al,ah		;construct a cell
			ror	al,cl		;assume char cell shift
			and	al,textpattern[bx]
			mov	es:[di],al	;set pixels with rotation
			add	di,scr_wid	;advance to next screen row
			inc	bp		;update previous char line ptr
			add	bx,2   		;next pattern row
			and	bx,01fh		;pattern paragraph offs
			dec	ch
		jnz	row_by_row_mid_p
	jmp	char_by_char_nba_p		;draw next char

	;----------- and now last character right part
	last_char_p:
	mov	ss,ss_store			;restore stack
	set_wr_mode	2
	set_rot_logic	0,repl_
	point_GPX_to	8			;point to write mask function
	mov	cl,rot_counter

	mov	si,prevch_ptr
	mov	ah,redge
	mov	ch,byte ptr vdots		;cx=vdots
	last_char_loop_p:				;set  character row by row
		mov	al,ah			;clip right edge
		out	dx,al			;set current mask
		cmp	es:[di],bh		;latch
		mov	al,textbcolor
		mov	es:[di],al		;set background pixels

		lodsb				;get current line of character
		ror	al,cl			;assume that bit shift exist
		and	al,ah			;clip with left edge
		and	al,textpattern[bx]

		out	dx,al			;set up current mask
		cmp	es:[di],bl		;latch
		mov	al,textcolor
		mov	es:[di],al		;set forground pixels

		add	di,scr_wid		;advance to new row
		add	bx,2			;next pattern row
		and	bx,01fh			;pattern paragraph offset
		dec	ch
	jnz	last_char_loop_p		;one more row ?
	;----------------------------------------
	put_string_exit:
	mov	ss,ss_store
	sti
	end_c_proc	_put_string ,8







CODE	ends

;*****************************************************************************
	public	InitGraphics
	public  LeaveGraphics
	public  set_line
	public  set_fill_pattern
	public  replace_colors
	public	rect_fill
	public	copy_region
	public	save_region
	public	put_string
	public	set_text_pattern
	public	set_text_color
	public	put_icon
	public	write_byte_block
	public	read_byte_block
	public	transffer_page
	public	set_current_page
	public	set_font
	public	set_char_cell
	public	set_draw_color
	public	set_draw_style
	public	set_line_logic
	public	set_text_style
END
